#include "slidenode.h"

#include "slideworld.h"
#include "slideface.h"

BOOL CSLIDENode::m_bRenderBound = FALSE;
BOOL CSLIDENode::m_bColorDynamicBounds = FALSE;

//////////////////////////////////////////////////////////////////////
// CSLIDENode Class
//

CSLIDENode::CSLIDENode()
{
}

CSLIDENode::~CSLIDENode()
{
}

VOID CSLIDENode::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID)
{
  CSLIDEPrimitive::Init(pcFile, uiLine, uiColumn, pcID);
}

VOID CSLIDENode::Uninit()
{
  CSLIDEPrimitive::Uninit();
}

BOOL CSLIDENode::Initialized()
{
  return CSLIDEPrimitive::Initialized();
}

BOOL CSLIDENode::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  return CSLIDEPrimitive::CheckSemantics(pCSLIDEWorld);
}

BOOL CSLIDENode::Valid()
{
  return CSLIDEPrimitive::Valid();
}

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 3: You may want to do some work in here
// 
VOID CSLIDENode::PreprocessGraph()
{
  // Initialize Boundedness Flags
}

VOID CSLIDENode::UpdateGraph()
{
}
// 
// END  : ASSIGNMENT 3: You may want to do some work in here
////////////////////////////////////////////////////////////////////////

VOID CSLIDENode::InsertIntoBound(const Matrix &/*m*/, CBound &/*bound*/)
{
  // This is the right thing to do for nodes with no bounds
  // like cameras and lights
}

VOID CSLIDENode::CalculateBound()
{
  // This is the right thing to do for nodes with no bounds
  // like cameras and lights
}

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 3: Rendering for Objects and Groups
// 
VOID CSLIDENode::Render(const Matrix &mGvp_proj, 
			const Matrix &mGproj_vrc, const Matrix &mGvrc_proj, 
			const Matrix &mGvrc_obj, const Matrix &mGobj_vrc, 
			CBound *pCBoundClip, 
			CListInt *plistLights,
			CSLIDESurface *pCSLIDESurface,
			SLIDEShadingType eShading, 
			SLIDELODType eLOD)
{
  ModifySurfacePointer(pCSLIDESurface);

  RenderGeometry(mGvp_proj, mGproj_vrc, mGvrc_proj, 
		 mGvrc_obj, mGobj_vrc, 
		 pCBoundClip, plistLights, pCSLIDESurface, 
		 eShading, eLOD);

  if ( GetRenderBound() )
    {
      RenderBound(mGvp_proj, mGproj_vrc, mGvrc_obj);
    }
}
// 
// END  : ASSIGNMENT 3: Rendering for Objects and Groups
////////////////////////////////////////////////////////////////////////

VOID CSLIDENode::ModifySurfacePointer(CSLIDESurface* &/*pCSLIDESurface*/)
{
}

VOID CSLIDENode::ModifyShadingFlag(SLIDEShadingType &/*eShading*/)
{
}

VOID CSLIDENode::ModifyLODFlag(SLIDELODType &/*eLOD*/)
{
}

VOID CSLIDENode::RenderGeometry(const Matrix &/*mGvp_proj*/, 
				const Matrix &/*mGproj_vrc*/, 
				const Matrix &/*mGvrc_proj*/, 
				const Matrix &/*mGvrc_obj*/, 
				const Matrix &/*mGobj_vrc*/, 
				CBound * /*pCBoundClip*/, 
				CListInt * /*plistLights*/,
				CSLIDESurface * /*pCSLIDESurface*/,
				SLIDEShadingType /*eShading*/, 
				SLIDELODType /*eLOD*/)
{
}

VOID CSLIDENode::RenderBound(const Matrix &/*mGvp_proj*/, 
			     const Matrix &/*mGproj_vrc*/, 
			     const Matrix &/*mGvrc_obj*/)
{
}


